/*
 * Mission.java
 *
 * Created on 11. jen 2006, 23:42
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package pa161.uloha_1;

import java.util.LinkedList;

/**
 *
 * @author xmatena
 */
public class Mission {
    
    /** Creates a new instance of Mission */
    public Mission() {
    }
    
    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        
        LinkedList<State> queue = new LinkedList<State>();
        State actualState = new State(3,3,true,null,0);
        
        //find state (0,0,0)
        while (!actualState.isSuccessful()) {
            //enqueue all successors 
            queue.addAll(actualState.getSuccessors());
            if (!queue.isEmpty()) {
                actualState = queue.remove();
            } else {
                System.out.println("Empty queue - solution not found");
                System.exit(2);
            }
            System.out.println(actualState.toString());
        }
        
        //print out the correct solution
        
        System.out.println("Found solution:");
        LinkedList<State> stack = new LinkedList<State>();
                
        while (actualState.getLastOperator() != 0) {
            stack.add(actualState);
            actualState = actualState.getLastState();
        }
        stack.add(actualState);
            
        while (!stack.isEmpty()) {
            System.out.println(stack.removeLast().toString());
            //System.out.println(stack.removeLast().getLastOperator());
            
        }
    }
    
}
